from zipfile import ZipFile,ZIP_DEFLATED,ZipInfo
from graph import GraphXML
from shapes import ShapesXML
from layout import FixedLayoutXML
from layout import SpringLayoutXML

class GraphFile:
    def __init__(self, filename, schemaPath):
        self.filename = filename
        self.schemaPath = schemaPath
        
    def save(self, graph, shapes, layout):
        savedFile = ZipFile(self.filename, "w", ZIP_DEFLATED)
        savedFile.write(self.schemaPath + "/Graph.xsd", "Graph.xsd")
        savedFile.write(self.schemaPath + "/Shapes.xsd", "Shapes.xsd")
        savedFile.write(self.schemaPath + "/Layout.xsd", "Layout.xsd")        
        thefile = ZipInfo("Graph.xml")
        thefile.external_attr = 0644 << 16L
        savedFile.writestr(thefile, graph.xml())
        thefile = ZipInfo("Shapes.xml")
        thefile.external_attr = 0644 << 16L
        savedFile.writestr(thefile, shapes.xml())
        thefile = ZipInfo("Layout.xml")
        thefile.external_attr = 0644 << 16L
        savedFile.writestr(thefile, layout.xml())
        savedFile.close()

if __name__ == '__main__':
    gfile = GraphFile("test.graph", "schemas")
    gfile.save(GraphXML(), ShapesXML(), SpringLayoutXML())
    
