from GVFiles.graph import GraphXML
from GVFiles.shapes import ShapesXML
from GVFiles.layout import FixedLayoutXML
from GVFiles.layout import SpringLayoutXML
from GVFiles.graphfile import GraphFile
import random

if __name__ == '__main__':
    order = 500
    size = 250
    # random graph with (order) nodes and (size) edges
    graph = GraphXML(order, size)
    for i in range(0, order):
        graph.addNode(i, str(i + 1))
    c = size
    edges = []
    while c > 0:
        a = random.randint(0, order - 1)
        b = random.randint(0, order  -1)        
        if a != b and (a, b) not in edges and (b, a) not in edges:
            c = c - 1
            graph.addEdge(c, a, b)
            
    # random shapes
    shapes = ShapesXML()
    for i in range(0, 6):
        for j in range(0, 27):
            if i == 0 or i == 2 or i == 3 or i == 5:
                mult = 1.3
            elif i == 1 or i == 4:
                mult = 2.0  
            else:
                mult = 1.0                          
            shapes.addShape(c, i, random.random(), random.random(), random.random(), 0.2, 1, 1, 1)
            c = c + 1
    for i in range(0, order):
        shapes.addNode(i, random.randint(0, c - 1))
     
    # spring layout
    layout = SpringLayoutXML()
    for i in range(0, order):
        layout.addNode(i, -1)
    for i in range(0, size):
        layout.addEdge(i, 0.9, 5.0)
          
    # input file
    gfile = GraphFile("rand_graph.graph", "GVFiles/schemas")
    gfile.save(graph, shapes, layout)
    