from GVFiles.graph import GraphXML
from GVFiles.shapes import ShapesXML
from GVFiles.layout import FixedLayoutXML
from GVFiles.layout import SpringLayoutXML
from GVFiles.graphfile import GraphFile
import random

if __name__ == '__main__':
    # genrate the graph
    graph = GraphXML(19, 0)
    graph.addNode(0, "Enclosing sphere")
    graph.addNode(1, "N98")
    graph.addNode(2, "D170")
    graph.addNode(3, "R189")
    graph.addNode(4, "D254")
    graph.addNode(5, "A255")
    graph.addNode(6, "A256")
    graph.addNode(7, "D257")
    graph.addNode(8, "S270")
    graph.addNode(9, "V272")
    graph.addNode(10, "T273")
    graph.addNode(11, "N300")
    graph.addNode(12, "M302")
    graph.addNode(13, "H303")
    graph.addNode(14, "I304")
    graph.addNode(15, "D305")
    graph.addNode(16, "A306")
    graph.addNode(17, "S354")
    graph.addNode(18, "C407")
    
    # build the shapes
    shapes = ShapesXML()
    shapes.addShape(0, 3, 0.933, 1.0, 0.290, 8, 1, 1, 1) 
    shapes.addShape(1, 0, 0.235, 0.349, 1.0, 0.6, 1, 1, 1)
    shapes.addShape(2, 0, 0.190, 0.600, 0.010, 0.6, 1, 1, 1)
    shapes.addNode(0, 0)
    shapes.addNode(4, 2)
    shapes.addNode(13, 2)
    shapes.addNode(18, 2)
    for i in range(1, 18):
        if i != 4 and i != 13:
            shapes.addNode(i, 1)    
        
    shapes.setLabelsCentered(0)
    shapes.setLabelsOffsetX(13)
    shapes.setLabelsOffsetY(13)
    shapes.setWiredWidth(1)
    shapes.setLabelsWidth(1.4)
    shapes.setLabelsSize(1.1)
    
    # build the fixed layout
    layout = FixedLayoutXML(47.6737, 68.7764, 12.7106)
    layout.addNode(0, 47.6737, 68.7764, 12.7106)
    layout.addNode(1, 48.3954, 75.7370, 9.2990)
    layout.addNode(2, 51.5376, 66.0678, 14.0732)
    layout.addNode(3, 55.3056, 68.8322, 11.1622)
    layout.addNode(4, 49.6832, 67.1796, 8.5530)
    layout.addNode(5, 49.3955, 62.0855, 9.9065)
    layout.addNode(6, 47.6875, 64.5400, 12.5415)
    layout.addNode(7, 44.3958, 66.7584, 9.4174)
    layout.addNode(8, 43.5292, 70.0595, 6.7625)
    layout.addNode(9, 47.9045, 70.8672, 7.0008)
    layout.addNode(10, 45.1408, 67.1180, 5.4864)
    layout.addNode(11, 42.4221, 73.5404, 15.2021)
    layout.addNode(12, 47.9598, 72.5778, 11.8104)
    layout.addNode(13, 47.6737, 68.7764, 12.7106)
    layout.addNode(14, 40.3974, 65.7964, 12.9262)
    layout.addNode(15, 44.1650, 65.5324, 17.1020)
    layout.addNode(16, 42.1675, 69.2910, 18.4000)
    layout.addNode(17, 47.4715, 73.8155, 18.7180)
    layout.addNode(18, 48.4277, 66.1460, 19.9147)
              
    # input file
    gfile = GraphFile("sphere.graph", "GVFiles/schemas")
    gfile.save(graph, shapes, layout)
    