from GVFiles.graph import GraphXML
from GVFiles.shapes import ShapesXML
from GVFiles.layout import FixedLayoutXML
from GVFiles.layout import SpringLayoutXML
from GVFiles.graphfile import GraphFile
import random

if __name__ == '__main__':
    # genrate the graph with 155 node 5 in the big clique and 50 smaller 
    # cliques around
    graph = GraphXML(155, 310)
    for i in range(0, 155):
        graph.addNode(i, "node " + str(i + 1))

    # building the bigger clique
    c = 0
    for i in range(0, 5):
        for j in range(i + 1, 5):
            graph.addEdge(c, i, j)
            c = c + 1

    i = 5
    n = 0
    while i < 155:
        graph.addEdge(c, i, i + 1)
        c = c + 1      
        graph.addEdge(c, i + 1, i + 2)
        c = c + 1      
        graph.addEdge(c, i, i + 2)
        c = c + 1      
        graph.addEdge(c, i, n)
        c = c + 1      
        graph.addEdge(c, i + 1, n)
        c = c + 1      
        graph.addEdge(c, i + 2, n)
        c = c + 1      
        n = (n + 1) % 5
        i = i + 3
    
    # build the shapes
    shapes = ShapesXML()
    shapes.addShape(0, 0, 0.235, 0.349, 1.0, 0.5, 1, 1, 1)
    shapes.addShape(1, 0, 0.190, 0.600, 0.010, 0.2, 1, 1, 1)
    for i in range(0, 5):    
        shapes.addNode(i, 0)
    for i in range(5, 155):    
        shapes.addNode(i, 1)
        
    shapes.setLabelsCentered(0)
    shapes.setLabelsOffsetX(13)
    shapes.setLabelsOffsetY(13)
    shapes.setWiredWidth(1)
    shapes.setLabelsWidth(1.4)
    shapes.setLabelsSize(1.1)
            
    # spring layout
    layout = SpringLayoutXML()
    for i in range(0, 155):
        layout.addNode(i, -1)
    for i in range(0, 10):
        layout.addEdge(i, 3, 1.0)
    for i in range(10, 310):
        layout.addEdge(i, 0.9, 5.0)
                  
    # input file
    gfile = GraphFile("tricky.graph", "GVFiles/schemas")
    gfile.save(graph, shapes, layout)
